#!/usr/bin/perl
use strict;
use warnings;
use Cwd;

#This program reads a xyz file then each atom kind of atom is numeroted corresponding to its line number in the xyz file. Then the script goes to the ANO-RCC file to read basis sets and the level of contraction given as parameter.


#input parameters :
#The first one is the name of the xyz file.
#The second one is the contraction level, if it is omitted, an error will occur.



#Opening of the input files : AOR-RCC and the xyz file
	open(my $input,  "<",  "$ARGV[0]")  or die "Can't open input: $!";
	open(my $input_base,  "<",  "ANO-RCC")  or die "Can't open input: $!";
#ouverture du fichier de sortie
	open(my $out, ">",  "$ARGV[0].seward.molcas") or die "Can't open output.txt: $!";

my $test=0;
my $num_ligne=0;
my $atom_type = ();
my $nb_atomes;
my %tableau_reor = ();
my $current_working_directory = getcwd();
my $ref_orb;
my $contraction;
my $auteur;
my $niv_contraction="$ARGV[1]";
my $key;
my $num_atome=1;

#Reading of the xyz file the first two lines are ignored
while (<$input>) 
{ 
	if($num_ligne>1 && /^\s*([A-Z]{1}[a-z]??)(\s*[\d\-\.]*\s*[\d\-\.]*\s*[\d\-\.]*)\s*$/)
	{
		$tableau_reor{$1}.=$1.$num_atome.$2." Angstrom\n";
		$num_atome++;
	}
	$num_ligne++;
}

#Start of the writing of the output file
print $out "&SEWARD &END\n";
print $out "title\n";
print $out "$ARGV[0] \n";

#For each kind of atom, we look in the ANO-RCC file to see the references for the author, the orbitals basis set and the contraction level.
foreach $key (keys %tableau_reor)
{
	open(my $input_base,  "<",  "ANO-RCC")  or die "Can't open input: $!";
	while (<$input_base>)
	{
		if($test==0 && m/^\/$key\.ano-rcc\.(\w*)\.(\w*)\.(\w*)\.$/)
		{
			$test=1;
			$ref_orb=$2;
			$auteur=$1;
		}
		if($test ==1 && m/^\*\s*$niv_contraction:\s*(\S*)[^*]*\*$/ )
		{
			$contraction=$1;
			$test=2;
		}
	}
#For hydrogens, a warning is generated.
	if($key eq "H"){print $out "#attention au niveau de contraction de H!!\n"}
print $out "basis set\n";	
print $out "$key\.ano-rcc\.$auteur\.$ref_orb\.$contraction\.\n";
print $out "$tableau_reor{$key}";
print $out "end of basis\n";	
#all keywords are initialized
$test=0;$auteur="";$ref_orb="";$contraction="";
}

#   

print $out "end of input\n";

